﻿using UnityEngine;
using System.Collections;

public class BulletScript : MonoBehaviour {

	public Vector3 targetPos;

	public float speed;

	public GameObject friend;

	private bool used;

	// Use this for initialization
	void Start () {
		//transform.LookAt(targetPos);
		//transform.LookAt(new Vector3(0,100,0));
		used = false;
	}
	
	// Update is called once per frame
	void Update () {
		if(GameManager.isPaused()) return;
		float travelDist = speed * Time.deltaTime;
		//RaycastHit hitinfo;
		//if(collider.Raycast(transform.position, transform.TransformDirection(Vector3.forward), out hitinfo, travelDist)){
		//Ray ray = new Ray(transform.position, transform.TransformDirection(Vector3.forward));
		//if(collider.Raycast(ray, out hitinfo, travelDist)){
		RaycastHit[] hits = Physics.RaycastAll(transform.position, transform.forward, travelDist);
		foreach(RaycastHit hit in hits){
			if(hit.collider.gameObject != friend){
				weveBeenHit(hit.collider);
				//print ("ray hit" + hit.collider.gameObject.name);
			}
		}
		transform.Translate(Vector3.forward * travelDist);
	}

	/*void OnTriggerEnter(Collider other){
		print ("collide with " + other.gameObject.name);
		Shootable shot = other.gameObject.GetComponent<Shootable>();

		if(shot != null){ //hit anything that extends shootable - namely players or enemies
			//print (shot.gameObject.name);
		}

		if(!other.gameObject.CompareTag("PhysicsIgnore")) Destroy(this.gameObject);
	}*/

	//void OnCollisionEnter(Collision coll){

	//}

	public void pointMe(Vector3 target){
		transform.LookAt(target);
	}

	void weveBeenHit(Collider other){
		if(used) return;
		used = true;
		//print ("collide with " + other.gameObject.name);
		Shootable shot = other.gameObject.GetComponent<Shootable>();
		
		if(shot != null){ //hit anything that extends shootable - namely players or enemies
			//print (shot.gameObject.name);
			shot.getShot();
		}

		if(!other.gameObject.CompareTag("PhysicsIgnore")) Destroy(this.gameObject);
	}
}
